##
##  NGPT - Next Generation POSIX Threading
##  Copyright (c) 2001 IBM Corporation <babt@us.ibm.com>
##  Portions Copyright (c) 1999-2000 Ralf S. Engelschall <rse@engelschall.com>
##
##  This file is part of NGPT a non-preemptive thread scheduling
##  library which can be found at http://www.ibm.com/developer
##
##  This library is free software; you can redistribute it and/or
##  modify it under the terms of the GNU Lesser General Public
##  License as published by the Free Software Foundation; either
##  version 2.1 of the License, or (at your option) any later version.
##
##  This library is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
##  Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public
##  License along with this library; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
##  USA.
##
##  ngpt.spec: RPM specification 
##

#   This is a specification file for the RedHat Package Manager (RPM).
#   It is part of the ngpt source tree and this way directly included in
#   ngpt distribution tarballs. This way one can use a simple `rpm -tb
#   ngpt-X.Y.Z.tar.gz' command to build binary RPM packages from a ngpt
#   distribution tarball.

%define prefix /usr
%define ver 1.0.1
%define rel 1

Name:       ngpt
Version:    %{ver}
Release:    %{rel}
Group:      System Environment/Libraries
Vendor:	    IBM
Copyright:  LGPL
URL:        http://oss.software.ibm.com/developerworks/opensource/pthreads
Summary:    NGPT - Next Generation POSIX Threading

Source:     http://oss.software.ibm.com/developerworks/openesource/pthreads/download/stable/source/ngpt-%{ver}.tar.gz
BuildRoot:  /tmp/ngpt-%{ver}-root

%description
NGPT is the user-level portion of a POSIX pthreads library which provides
non-preemptive priority-based scheduling for multiple threads of
execution (aka ``multithreading'') inside event-driven applications. All
threads run in the same address space of the server application, but each
thread has it's own individual program-counter, run-time stack, signal
mask and errno variable.

On SMP machines, this library will use an M:N threading model if enabled
resulting in significantly improved performance.

IMPORTANT NOTICE: 
This package is currently in pre-alpha form.  It is intended to be
used only in controlled testing environment. It should not be used
in a production environment.

%package devel
Summary: NGPT Development Package
Group: Development/Libraries
Requires: ngpt = %{ver}

%description devel
Headers, static libraries, and documentation for NGPT.

%prep

%setup

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix} --enable-kernel-patch --enable-batch --enable-optimize --enable-pthread --enable-syscall-hard --enable-maintainer
make
make test

%install
rm -rf $RPM_BUILD_ROOT
make install prefix=$RPM_BUILD_ROOT%{prefix}

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc ANNOUNCE AUTHORS COPYING ChangeLog HACKING HISTORY INSTALL NEWS PORTING README SUPPORT TESTS THANKS TODO USERS
%{prefix}/lib/libngpt.so
%{prefix}/lib/libpthread.so
%{prefix}/lib/libngpt.so.*
%{prefix}/lib/libpthread.so.*

%files devel
%defattr(-,root,root)
%{prefix}/bin/pthread-config
%{prefix}/include/pthread.h
%{prefix}/include/bits/pthreadtypes.h
%{prefix}/include/bits/sigthread.h
%{prefix}/lib/libngpt.a
%{prefix}/lib/libpthread.a
%{prefix}/lib/libngpt.la
%{prefix}/lib/libpthread.la
%{prefix}/man/man1/pthread-config.1.gz
%{prefix}/man/man3/pthread.3.gz
%{prefix}/share/aclocal/ngpt.m4

